-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2016.4
-- Copyright (C) 1986-2017 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
--use IEEE.std_logic_unsigned.all;
use IEEE.numeric_std.all;

entity tb is
end entity tb;


architecture arch of tb is 

	signal clk, rst, start, ready, done, idle : std_logic;
	signal rd_req	: std_logic;
	signal addr		: std_logic_vector(3 downto 0);
	signal dout		: std_logic_vector(31 downto 0);
	
begin
	-- Sort top level module
	uut: entity work.top(behav)
		port map(	clk	=> clk,
						rst	=> rst,
						start	=> start,
						ready	=> ready,
						done	=> done,
						idle	=> idle,
						rd_req	=> rd_req, 
						rd_addr => addr, 
						rd_dout => dout
						);
					
	process
	begin
		clk <= '0';
		wait for 1 ns;
		clk <= '1';
		wait for 1 ns;
	end process;
	
	process
	begin
		rst <= '1';
		wait for 5 ns;
		rst <= '0';
		wait;
	end process;
	
	process
		constant iter : integer := 2**4;
	begin
	   start <= '0';
		wait until rst = '0';
		start <= '1';
		wait until done = '1';
		start <= '0';
		for I in 0 to iter loop
			wait until rising_edge(clk);
			rd_req <= '1';
			addr <= std_logic_vector(to_unsigned(I, addr'length));
		end loop;
		wait;
	end process;
end architecture arch;