-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2016.4
-- Copyright (C) 1986-2017 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity top is
	port (	clk		: in std_logic;
				rst		: in std_logic;
				start		: in std_logic;
				ready		: out std_logic;
				done		: out std_logic;
				idle     : out std_logic;
				rd_req	: in std_logic;
				rd_addr		: in std_logic_vector(3 downto 0);
				rd_dout		: out std_logic_vector(31 downto 0)
				);
end entity;

architecture behav of top is 
    
	 type ram_type is array(0 to 15) of std_logic_vector(31 downto 0);  

	 shared variable M : ram_type := ( x"00000000", 
	                                   x"00000081", 
	                                   x"00000084", 
	                                   x"00000023", 
	                                   x"00000056", 
	                                   x"00000063", 
	                                   x"00000039", 
	                                   x"00000012", 
	                                   x"00000089", 
	                                   x"0000008A",
	                                   others => x"00000000");
			
	signal M_address0 : STD_LOGIC_VECTOR (3 downto 0);
	signal M_ce0 :  STD_LOGIC;
	signal M_we0 :  STD_LOGIC;
	signal M_d0 :  STD_LOGIC_VECTOR (31 downto 0);
	signal M_q0 :  STD_LOGIC_VECTOR (31 downto 0);
	signal M_address1 :  STD_LOGIC_VECTOR (3 downto 0);
	signal M_ce1 :  STD_LOGIC;
	signal M_we1 :  STD_LOGIC;
	signal M_d1 :  STD_LOGIC_VECTOR (31 downto 0);
begin

	sort_unit : entity work.sort(behav)
			port map (
					ap_clk => clk,
					ap_rst => rst,
					ap_start => start,
					ap_done => done,
					ap_idle => idle,
					ap_ready => ready,
					M_address0 => M_address0,
					M_ce0 => M_ce0,
					M_we0 => M_we0,
					M_d0 => M_d0,
					M_q0 => M_q0,
					M_address1 => M_address1,
					M_ce1 => M_ce1,
					M_we1 => M_we1,
					M_d1 => M_d1);

	
	-- Memory access on port #0	
	process (CLK)
	begin
		if rising_edge(CLK) then
			if M_ce0 = '1' then
				M_q0 <= M(conv_integer(M_address0));
				if M_we0 = '1' then 
					M(conv_integer(M_address0)) := M_d0;
				end if;
			end if;
		end if;
	end process;
	
	-- Memory access on port #1
	process (CLK)
	begin
		if rising_edge(CLK) then
			if M_ce1 = '1' then
				if M_we1 = '1' then 
					M(conv_integer(M_address1)) := M_d1;
				end if;
			end if;
		end if;
	end process;
	
	process (clk)
	begin
		if rising_edge(clk) then
			if (rd_req = '1') then
				rd_dout <= M(conv_integer(rd_addr));
			end if;
		end if;
	end process;
end architecture behav;